<?php
error_reporting(E_ALL & ~E_NOTICE);
function page_conclusion () {
	
	$GLOBALS["heading"] = 'Auswertung';
	
	// Was war die benoetigte Zeit?
	$zeit = time() - $_SESSION["kopfrechnen"]["zeit"];
	$_SESSION["kopfrechnen"]["zeit"] = $zeit;
	
	// War das ein Wettbewerb? Und wichtiger, hat er es in den Highscore geschafft?
	if ($_SESSION["kopfrechnen"]["action"] == "wettbewerb") {
		
		// Welcher Modus:
		$modus = "Wettbewerb";
		$richtige_o_runden = 'Richtige Antworten: ';
		$fragen = "30";
		
		// Selektiere den schlechtesten Wert:
		$alter_stand = mysqli_fetch_object(mysqli_query($GLOBALS["verbindung"], "SELECT richtige, zeit FROM kopfrechnen
		ORDER BY richtige, zeit DESC LIMIT 0, 1"));
		
		
		if ($alter_stand->richtige < $_SESSION["kopfrechnen"]["richtige"]
		|| $alter_stand->richtige == $_SESSION["kopfrechnen"]["richtige"]
		&& $alter_stand->zeit > $zeit) {
			
			// Er war besser:
			$add_to_table = '<tr>
			<td><p>Highscore: </p></td>
			<td><form action="#" method="post" onsubmit="send_highscore(); return false;">
			<p>Herzlichen Gl&uuml;ckwunsch, Sie haben es in den Highscore geschafft!<br />
			<input type="text" id="name" placeholder="Dein Name" />
			<input type="submit" value="Speichern" id="button" /></p>
			</form></td>
			</tr>';
			
		}
	
	}
	
	// So sieht das aus fuer Mathespass:
	elseif ($_SESSION["kopfrechnen"]["action"] == "spass") {
		
		// Welcher Modus:
		$modus = "Mathespa&szlig;";
		$richtige_o_runden = 'Gebrauchte Durchg&auml;nge: ';
		$fragen = "15";
		
	}
	
	elseif ($_SESSION["kopfrechnen"]["action"] == "benutzerdefiniert") {
		
		// War das mit Spass oder Wettbewerb?
		if ($_SESSION["kopfrechnen"]["config_mode"] == "spass") {
			$richtige_o_runden = 'Gebrauchte Durchg&auml;nge: ';
			$add_to_table = '<tr>
			<td><p>Fragentyp: </p></td>
			<td><p>Alle Fragen mussten beantwortet werden.</p></td>
			</tr>';
		}
		else {
			$richtige_o_runden = 'Richtige Antworten: ';
			$add_to_table = '<tr>
			<td><p>Fragentyp: </p></td>
			<td><p>Jede Rechnung wurde nur einmal gestellt.</p></td>
			</tr>';
		}
		
		// Welcher Modus:
		$modus = "Benutzerdefiniert";
		$fragen = $_SESSION["kopfrechnen"]["config_fragen"];
		
	}
	
	else {
		
		// Ein Fall der nicht eintreten sollte
		exit;
		
	}
	
	
	// Die Ausgabe:
	$GLOBALS["echo"] = '<table border="0" style="width: 100%"><tr>
	<td style="width: 30%;"><p>Modus: </p></td>
	<td style="width: 70%;"><p>' . $modus . '</p></td>
	</tr><tr>
	<td><p>Ben&ouml;tigte Zeit: </p></td>
	<td><p>' . $zeit . ' Sekunden</p></td>
	</tr><tr>
	<td><p>Anzahl Fragen: </p></td>
	<td><p>' . $fragen . '</p></td>
	</tr><tr>
	<td><p>' . $richtige_o_runden . '</p></td>
	<td><p>' . $_SESSION["kopfrechnen"]["richtige"] . '</p></td>
	</tr>' . $add_to_table . '</table>
	<p><a href="index.php" style="font-weight: bold;">Zum Hauptmen&uuml;</a></p>';
		
}


function page_wettbewerb () {
	$GLOBALS["heading"] = 'Wettbewerb';
	
	// Damit nicht geschummelt werden kann die Action festlegen:
	$_SESSION["kopfrechnen"]["action"] = 'wettbewerb';
	$_SESSION["kopfrechnen"]["zeit"] = time();
	$_SESSION["kopfrechnen"]["richtige"] = 0;
	
	// Danach die Rechnungen generieren:
	$rechnungen = array_restack(neue_rechnungen(50, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, 3, 30));
	
	// Das Quiz starten und direkt ausgeben:
	$GLOBALS["echo"] = the_quiz($rechnungen);
	
}

function page_spass () {
	$GLOBALS["heading"] = 'Mathespa&szlig;';
	
	// Damit nicht geschummelt werden kann die Action festlegen:
	$_SESSION["kopfrechnen"]["action"] = 'spass';
	$_SESSION["kopfrechnen"]["zeit"] = time();
	$_SESSION["kopfrechnen"]["richtige"] = 0;
	
	// Danach die Rechnungen generieren:
	$rechnungen = array_restack(neue_rechnungen(50, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, 3, 15));
	
	// Das Quiz starten und direkt ausgeben:
	$GLOBALS["echo"] = the_quiz($rechnungen);
}



function page_benutzerdefiniert () {
	$GLOBALS["heading"] = 'Benutzerdefinierte Rechnungen';
	
	
	// Die Eingaben validieren:
	$maximalwert = $_POST["maximalwert"];
	$anzahl_therme = $_POST["anzahl_therme"] + 1;
	$anzahl = $_POST["anzahl"];
	$parameter = array();
	$parameter[] = ($_POST["addition"] == "1"?true:false);
	$parameter[] = ($_POST["subtraktion"] == "1"?true:false);
	$parameter[] = ($_POST["multiplikation"] == "1"?true:false);
	$parameter[] = ($_POST["division"] == "1"?true:false);
	$parameter[] = ($_POST["sup2"] == "1"?true:false);
	$parameter[] = ($_POST["sup3"] == "1"?true:false);
	$parameter[] = ($_POST["wurzel"] == "1"?true:false);
	$modus = $_POST["modus"];
	
	// Sind die Eingaben gemacht worden?
	if ($maximalwert > 0 && $maximalwert < 500 && $anzahl_therme > 1 && $anzahl_therme < 15
	&& $anzahl > 0 && $anzahl < 50 && ($modus == "spass" || $modus == "wettbewerb")) {
		
		// Fuer die Auswertung:
		$_SESSION["kopfrechnen"]["action"] = 'benutzerdefiniert';
		$_SESSION["kopfrechnen"]["config_mode"] = $modus;
		$_SESSION["kopfrechnen"]["config_fragen"] = $anzahl;
		$_SESSION["kopfrechnen"]["zeit"] = time();
		$_SESSION["kopfrechnen"]["richtige"] = 0;
		
		// Danach die Rechnungen generieren:
		$rechnungen = array_restack(neue_rechnungen($maximalwert, $parameter[0], $parameter[1], $parameter[2],
		$parameter[3], $parameter[4], $parameter[5], $parameter[6], $anzahl_therme, $anzahl));
		
		// Das Quiz starten und direkt ausgeben:
		$GLOBALS["echo"] = the_quiz($rechnungen);
			
	}
	
	else {
		
		// Die Ausgabe der Parametereinstellungen
		$GLOBALS["echo"] = '<a href="index.php">&larr; Zur&uuml;ck zum Men&uuml;</a>
		<p style="text-align: center;">Bitte geben Sie hier Ihre gew&uuml;nschten Parameter an:</p>
		<form action="index.php?action=benutzerdefiniert" method="post">
		<table border="0" style="width: 100%;"><tr>
		<td>Maximalwert pro Einzelzahl: </td>
		<td><input type="text" name="maximalwert" value="50" size="3" /></td>
		<td rowspan="3" style="vertical-align: top;">
		<input type="radio" name="modus" value="spass" checked="checked" />
		Jede Aufgabe muss gel&ouml;st werden<br />
		<input type="radio" name="modus" value="wettbewerb" />
		Jede Aufgabe kommt nur einmal</td>
		</tr><tr>
		<td style="padding-right: 20px;">Anzahl der Opperanten: </td>
		<td><input type="text" name="anzahl_therme" value="2" size="3" /></td>
		</tr><tr>
		<td style="padding-right: 20px;">Anzahl der Rechnungen: </td>
		<td><input type="text" name="anzahl" value="20" size="3" /></td>
		</tr></table>
		
		<table border="0" style="width: 100%; margin: 20px;"><tr>
		<td style="width: 25%;"><input type="checkbox" name="addition" value="1" checked="checked" />
		Addieren</td>
		<td style="width: 25%;"><input type="checkbox" name="subtraktion" value="1" checked="checked" />
		Subtrahieren</td>
		<td style="width: 25%;"><input type="checkbox" name="multiplikation" value="1" checked="checked" />
		Multiplizieren</td>
		<td style="width: 25%;"><input type="checkbox" name="division" value="1" checked="checked" />
		Dividieren</td>
		</tr><tr>
		<td><input type="checkbox" name="sup2" value="1" checked="checked" />
		Quadrieren</td>
		<td><input type="checkbox" name="sup3" value="1" checked="checked" />
		Kubizieren</td>
		<td colspan="2"><input type="checkbox" name="wurzel" value="1" checked="checked" />
		Wurzel ziehen</td>
		</tr></table>
		
		<div style="text-align: center;"><input type="submit" value="Starten" />
		<input type="reset" value="Zur&uuml;cksetzen" /></div>
		</form>';
		
	}
	
}



function the_quiz ($rechnungen) {
	
	// Die Loesungen zu den vorher bestimmten Rechnungen ermitteln:
	/* Seid Version 1.1 rausgekickt
	foreach ($rechnungen as $rechnung) {
		$loesungen[] = calculate_string($rechnung);
	}*/
	
	// Damit ich auch laenger was davon habe, werde ich diese beiden nun in der SESSION eintragen:
	$_SESSION["kopfrechnen"]["rechnungen"] = $rechnungen;
	
	// Seid Version 1.1 rausgekickt, weil die Ergebnisse spezifisch neu geloest werden:
	// $_SESSION["kopfrechnen"]["loesungen"] = $loesungen;
	
	
	// Dann nimm mal die erste Frage und mach sie schick:
	$zufall = mt_rand(0, count($rechnungen) - 1);
	$frage = make_nice_calc($rechnungen[$zufall]);
	
	// Anschliessend generiere das Template:
	$template = '<form method="post" action="#" onsubmit="sende_formular(); return false;">
	<p style="text-align: center;">Die Ergebnisse werden auf ganze Zahlen gerundet (0,5 &rarr; 1).
	Daher ist eine Angabe von Gleitkommastellen nicht notwendig!<br />
	<a href="index.php">&larr; Abbrechen und zur&uuml;ck zum Men&uuml;</a></p>
	<div id="old-equal">Noch <span style="font-weight: bold;" id="noch">' . count($rechnungen) . '</span> Fragen!</div>
	<div id="new-equal"><span id="frage">' . $frage . '</span> =
	<input type="text" id="loesung" size="4" /></div>
	<input type="hidden" id="id_wert" value="' . $zufall . '" /></form>';
	
	return $template;
	
}



function make_nice_calc ($rechnung) {
	
	// Array fuer die Normalkalkulationen
	$opperanten_suche = array('+', '-', '*', '/', 'r', '^2', '^3');
	$opperanten_ersetze = array(' + ', ' - ', ' * ', ' / ', ' &radic;', '&sup2; ', '&sup3; ');
	
	return str_replace($opperanten_suche, $opperanten_ersetze, $rechnung);
	
}


// Funktion zur Berechnung des Strings:
function calculate_string ($mathString) {
	// Zuerst die Wurzelfunktionen:
	$wurzeln = array();
	preg_match_all('!r(\d)+?([\/\+\-\*]|$)!', $mathString, $wurzeln, PREG_SET_ORDER);
	// In diesem Wurzelarray ist nun nur der nullte Wert von Bedeutung, der am Anfang noch das r, am Ende noch den Operanden hat
	foreach ($wurzeln as $wurzel) {
		// Die gefunden Wurzeln extrahieren, parsen und ersetzen:
		$einfachwurzel = sqrt(preg_filter('/\D/', '', $wurzel[0]));
		
		// Und jetzt in den mathstring einsetzen:
		$mathString = str_replace($wurzel[0], $einfachwurzel . $wurzel[2], $mathString);
	}
	
	
	// Mitten drinne halt mal die Quadrat und Kubikfunktion:
	$potenzen = array();
	preg_match_all('!(^|[\+\-\*\/])(\d+?)\^([23])([\+\-\*\/]|$)!', $mathString, $potenzen, PREG_SET_ORDER);
	// Nachdem wir das haben einfach den Wert extrahieren:
	foreach ($potenzen as $potenz) {
		// Die Geschichte berechnen:
		$einfachpotenz = pow($potenz[2], $potenz[3]);
		
		// Und zum Schluss noch in die Rechnung einfuegen:
		$mathString = str_replace($potenz[0], $potenz[1] . $einfachpotenz . $potenz[4], $mathString);
	}
	
	
	// Danach den Rest durchrechnen
    $mathString = trim($mathString);
    $mathString = preg_replace('[^0-9\+-\*\/\(\) ]', '', $mathString);
	
    $compute = create_function("", "return (" . $mathString . ");" );
    return round(0 + $compute(), 0, PHP_ROUND_HALF_UP);
}



// Diese Funktion gibt viele neue Rechnung aus.
function neue_rechnungen ($maximalwert, $addition, $subtraktion,
$multiplikation, $division, $sup2, $sup3, $wurzel, $anzahl_therme, $anzahl) {
	
	// Was darf alles gemacht werden?
	$zufallsrechnung = array();
	$specialfuncs = array();
		
	// Addition erlaubt?
	if ($addition == true)
		$zufallsrechnung[] = "+";
	// Subtraktion erlaubt?
	if ($subtraktion == true)
		$zufallsrechnung[] = "-";
	// Multiplikation erlaubt?
	if ($multiplikation == true)
		$zufallsrechnung[] = "*";
	// Division erlaubt?
	if ($division == true)
		$zufallsrechnung[] = "/";
	// Quadrieren erlaubt?
	if ($sup2 == true)
		$specialfuncs[] = mt_rand(1, 25) . "^2";
	// Kubizieren erlaubt?
	if ($sup3 == true)
		$specialfuncs[] = mt_rand(1, 10) . "^3";
	// Quadratwurzel ziehen erlaubt?
	if ($wurzel == true)
		$specialfuncs[] = 'r' . pow(mt_rand(1, 20), 2);
	
	
	// Zur Sicherheit gucken, ob mindestens eine Rechenart erlaubt ist:
	if (count($zufallsrechnung) < 1)
		return false;
	// Gucken, ob Maximalwert ueber oder gleich 5:
	if ($maximalwert < 5)
		return false;
	// Gucken, ob die Anzahl der Therme ueber 2 liegt und unter 15:
	if ($anzahl_therme < 2 || $anzahl_therme > 15)
		return false;
	// Gucken, ob nicht mehr als 30 Einzeltherme verlangt wird:
	if ($anzahl <= 0 || $anzahl > 30)
		return false;
	
	
	// Errechnen wir, mit welcher Wahrscheinlichkeit eine Specialfunc oder eine regulaere Zahl kommt:
	$zahl_oder_func = $maximalwert + count($specialfuncs);
	
	// Hier werden mehr solche Fragen erzeugt
	$i = 0;
	while ($i < $anzahl) {
		
		$i++;
		$zahlenmenge = array();
		
		// Fuer die Anzahl der Therme sorgen wir durch die Anzahl der bereitgestellten Funktionen
		$a = 0;
		while ($a < $anzahl_therme) {
			
			$a++;
			
			// Welche Zahl, bzw. welche Funktion?
			$zahl = mt_rand(1, $zahl_oder_func);
			
			// Hierbei handelt es sich um eine Spezialfunktion
			if ($zahl > $maximalwert) {
				$zahl = $specialfuncs[$zahl - $maximalwert - 1];
			}
			
			// Und die Zahl in einen Array fuer die Weiterverarbeitung schreiben:
			$zahlenmenge[] = $zahl;
			
		}
		
		
		// Nachdem ich alle Zahlen habe, muss ich diese nur noch mit den entsprechenden
		// Konnektoren verbinden:
		$a = 0;
		foreach ($zahlenmenge as $einzelzahl) {
			$a++;
			
			// Der erste Wert braucht keine Rechnung
			if ($a > 1) {
				// Die Zufallsrechnung bestimmen:
				$ausgabe[$i] .= $zufallsrechnung[mt_rand(0, (count($zufallsrechnung) - 1))] . $einzelzahl;
			}
			else {
				$ausgabe[$i] .= $einzelzahl;	
			}
			
		}
		
		
		
	}
	
	
	// Alles fertig, also schicken wir den Quatsch los:
	return $ausgabe;
}



// Der Sinn bei dieser Funktion ist lediglich darin, den Array neu auf die Nullposition auszurichten.
function array_restack ($input_array) {
	
	foreach ($input_array as $string) {
		
		$output_array[] = $string;
		
	}
	
	return $output_array;
	
}


?>
