<?php
// Die elementaren Sachen halt:
session_start();
require_once "mysql_inc.php";
require_once "functions_inc.php";


// Alles stehen und liegen lassen, wenn ein Name gepostet wurde:
if ($_POST["high_name"] != "" && $_SESSION["kopfrechnen"]["action"] == "wettbewerb") {
	
	$name = $_POST["high_name"];
	
	if (strlen($name) > 15)
		die("Der Name darf nicht länger sein als 15 Zeichen");
	
	$sql = mysqli_query($verbindung, "UPDATE kopfrechnen SET name = '" . $name . "',
	richtige = '" . $_SESSION["kopfrechnen"]["richtige"] . "', zeit = " . $_SESSION["kopfrechnen"]["zeit"] . "
		WHERE richtige < " . $_SESSION["kopfrechnen"]["richtige"] . "
		OR richtige = " . $_SESSION["kopfrechnen"]["richtige"] . "
		AND zeit > " . $_SESSION["kopfrechnen"]["zeit"] . "
	ORDER BY richtige, zeit DESC
	LIMIT 1");
	
	if ($sql) {
		echo 'OK';
		$_SESSION["kopfrechnen"] = array();
	}
	else
		echo mysqli_error($verbindung);
	
	exit;
	
}


// Wenn Modus Benutzerdefiniert:
if ($_SESSION["kopfrechnen"]["action"] == "benutzerdefiniert") {
	$modus = $_SESSION["kopfrechnen"]["config_mode"];
}
else {
	$modus = $_SESSION["kopfrechnen"]["action"];
}

// Nach den verschiedenen Modi aufteilen:
switch ($modus) {
	case "wettbewerb":
		
		// Im Modi Wettbewerb:
		// Hier wird nach jeder beantworteten Frage der aktuelle Wert entfernt und der naechste genommen:
		$id_wert = $_POST["id_wert"];
		$loesung = round(str_replace(",", ".", $_POST["loesung"]), 0, PHP_ROUND_HALF_UP);
		
		$richtig = calculate_string($_SESSION["kopfrechnen"]["rechnungen"][$id_wert]);
		
		// Ist die eingegebene Loesung richtig?
		if ($richtig == $loesung) {
			$_SESSION["kopfrechnen"]["richtige"]++;
		}
		
		// Den Eintrag aus der Liste entfernen:
		$_SESSION["kopfrechnen"]["rechnungen"][$id_wert] = "";
		// $_SESSION["kopfrechnen"]["loesungen"][$id_wert] = "";
		$_SESSION["kopfrechnen"]["rechnungen"] = array_restack(array_filter($_SESSION["kopfrechnen"]["rechnungen"]));
		// $_SESSION["kopfrechnen"]["loesungen"] = array_restack(array_filter($_SESSION["kopfrechnen"]["loesungen"]));
		
		
		// Ist noch ein Eintrag da?
		if (count($_SESSION["kopfrechnen"]["rechnungen"]) > 0)
			echo '0!' . make_nice_calc($_SESSION["kopfrechnen"]["rechnungen"][0])
			. '!' . count($_SESSION["kopfrechnen"]["rechnungen"]) . '!OK!' . $richtig;
		else
			echo 'done';
		
	break;
	case "spass":
		
		// Im Modi Spass:
		// Hier wird nach jeder beantworteten Frage der aktuelle Wert entfernt und der naechste genommen:
		$id_wert = $_POST["id_wert"];
		$loesung = round(str_replace(",", ".", $_POST["loesung"]), 0, PHP_ROUND_HALF_UP);
		
		// Den Wert fuer Versuche erhoehen
		$_SESSION["kopfrechnen"]["richtige"]++;
		
		// Den richtigen Wert berechnen
		$richtig = calculate_string($_SESSION["kopfrechnen"]["rechnungen"][$id_wert]);
		
		// Ist die eingegebene Loesung richtig?
		if ($richtig == $loesung) {
			
			// Den Eintrag aus der Liste entfernen:
			$_SESSION["kopfrechnen"]["rechnungen"][$id_wert] = "";
			// $_SESSION["kopfrechnen"]["loesungen"][$id_wert] = "";
			$_SESSION["kopfrechnen"]["rechnungen"] = array_restack(array_filter($_SESSION["kopfrechnen"]["rechnungen"]));
			// $_SESSION["kopfrechnen"]["loesungen"] = array_restack(array_filter($_SESSION["kopfrechnen"]["loesungen"]));
			
		}
		
		
		// Ist noch ein Eintrag da?
		if (count($_SESSION["kopfrechnen"]["rechnungen"]) > 0) {
			$zufall = mt_rand(0, count($_SESSION["kopfrechnen"]["rechnungen"]) - 1);
			echo $zufall . '!' . make_nice_calc($_SESSION["kopfrechnen"]["rechnungen"][$zufall])
			. '!' . count($_SESSION["kopfrechnen"]["rechnungen"]) . '!OK';
		}
		else
			echo 'done';
		
	break;
	default:
		echo 'ERROR';
	break;
}



// Die Mysql-Verbindung schliessen
mysqli_close($verbindung);
?>
