function send_highscore () {
	
	var high_name = $('#name').val();
	
	if (high_name == "") {
		alert("Das Feld ist noch leer!");
		return false;
	}
	
	// Den Namen abschicken:
	$.post("js_funcs.php", {"high_name": high_name}, function (data) {
		
		// Speichern erfolgreich?
		if (data == "OK") {
			// Feld ausgrauen:
			$('#name').prop("disabled", true);
			$('#button').prop("disabled", true);
		}
		// Speichern nicht erfolgreich?
		else {
			alert(data);
		}
		
	});
	
}


function sende_formular () {
	
	// Die Eingangsgroessen definieren
	var id_wert = $('#id_wert').val();
	var loesung = $('#loesung').val();
	
	// An js_funcs schicken:
	$.post("js_funcs.php", {"id_wert": id_wert, "loesung": loesung}, function (data) {
		
		// Wenn der Datenstring done ist, dann wird beendet:
		if (data == "done") {
			window.location.href = 'index.php?action=conclusion';
			return true;
		}
		
		
		// Die Daten enthalten vier Werte getrennt von !
		// Aktuelle ID, neue Aufgabe, noch-so-viele-aufgaben, OK-Wert
		var aufgeteilt = data.split("!");
		
		// Ist der String vollstaendig?
		if (aufgeteilt[3] != "OK") {
			alert("Es gab einen Kommunikationsfehler!");
			return true;
		}
		
		// Die Werte neu einfuegen:
		$('#loesung').val("");
		$('#id_wert').val(aufgeteilt[0]);
		$('#frage').html(aufgeteilt[1]);
		$('#noch').html(aufgeteilt[2]);
		$('#loesung').attr("placeholder", aufgeteilt[4]);
		
	});
	
}
